#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings

namespace VVVV.Nodes
{
	public class C1
	{
		
	}
	
	public class C2
	{
		
	}
	
	[PluginInfo(Name = "TestNodeIn", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	public class ValueTestNodeInNode : IPluginEvaluate, IPartImportsSatisfiedNotification
	{
		[ImportAttribute()]
		protected IPluginHost host1;
		
		private INodeIn testIn;
		
		private INodeIn testIn2;
		
		[OutputAttribute("Connected")]
		protected ISpread<bool> cnx;
		
		public void OnImportsSatisfied()
		{
			host1.CreateNodeInput("Input Not Working",TSliceMode.Single, TPinVisibility.True,out testIn);
			host1.CreateNodeInput("Input Works",TSliceMode.Single, TPinVisibility.True,out testIn2);
			
			testIn.SetSubType(new Guid[] { typeof(C1).GUID,typeof(C2).GUID  }, "Hello");
			
			testIn2.SetSubType(new Guid[] { typeof(C1).GUID }, "Hello");
		}
		
		public void Evaluate(int SpreadMax)
		{
			cnx[0] = testIn.IsConnected;
		}
	}
	
	[PluginInfo(Name = "TestNodeOut", Category = "Value", Help = "Basic template with one value in/out", Tags = "")]
	public class ValueTestNodeOutNode : IPluginEvaluate, IPartImportsSatisfiedNotification
	{
		[ImportAttribute()]
		protected IPluginHost host1;
		
		private INodeOut testOut;
		
		/*[OutputAttribute("Connected")]
		protected ISpread<bool> cnx;*/
		
		public void OnImportsSatisfied()
		{
			host1.CreateNodeOutput("Output",TSliceMode.Single, TPinVisibility.True,out testOut);
			testOut.SetSubType(new Guid[] { typeof(C1).GUID }, "Hello");
		}
		
		public void Evaluate(int SpreadMax)
		{
	
		}
	}
}
